class Element
  attr_reader :value, :next_ref

  def initialize(value, next_ref)
    @value = value
    @next_ref = next_ref
  end
end

# リストを組み立てる
d = Element.new(4, nil)
c = Element.new(3, d)
b = Element.new(2, c)
a = Element.new(1, b)

# 先頭の値からすべての要素にアクセスできる
p a.value # => 1
p a.next_ref.value # => 2
p a.next_ref.next_ref.value # => 3
p a.next_ref.next_ref.next_ref.value # => 4
